-- name: [CS] Mother Protagonists
-- description: This pack features Every protagonist from Mother (EB Beginings), Mother 2 (Earthbound) and Mother 3, along with a few extras!(This pack is currently a public BETA for the CS competiton. Let me know of any bugs!)\n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

-- I plan on expanding this mod in the future! stay tuned for that!

local TEXT_MOD_NAME = "The Mother Protagonists Pack"

-- Stops mod from loading if Character Select isn't on
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local E_MODEL_NESS = smlua_model_util_get_id("ness_geo") -- Located in "actors"
local E_MODEL_NINTEN = smlua_model_util_get_id("ninten_geo") -- Located in "actors"
local E_MODEL_KEN = smlua_model_util_get_id("ken_geo") -- Located in "actors"
local E_MODEL_LUCAS = smlua_model_util_get_id("lucas_geo") -- Located in "actors"
local E_MODEL_DOUG = smlua_model_util_get_id("douglas_geo") -- Located in "actors"
local E_MODEL_EB64LUCAS = smlua_model_util_get_id("eb64_lucas_geo") -- Located in "actors"

local TEX_NESS_LIFE_ICON = get_texture_info("ness-icon") -- Located in "textures"
local TEX_NINTEN_LIFE_ICON = get_texture_info("ninten-icon") -- Located in "textures"
local TEX_KEN_LIFE_ICON = get_texture_info("ken-icon") -- Located in "textures"
local TEX_LUCAS_LIFE_ICON = get_texture_info("lucas-icon") -- Located in "textures"
local TEX_DOUG_LIFE_ICON = get_texture_info("doug-icon") -- Located in "textures"
local TEX_EB64LUCAS_LIFE_ICON = get_texture_info("lucas64-icon") -- Located in "textures"

--[[
 Voices to be made in the future, here, have placeholder silence for now.
-- All Located in "sound"
local VOICETABLE_NESS = {
    [CHAR_SOUND_ATTACKED] = 'NES-Hit.ogg',
    [CHAR_SOUND_DOH] = 'NES-Bump.ogg',
    [CHAR_SOUND_DROWNING] = 'NES-Die.ogg',
    [CHAR_SOUND_DYING] = 'NES-Die.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'NES-Squish.ogg',
    [CHAR_SOUND_HAHA] = 'NES-1up.ogg',
    [CHAR_SOUND_HAHA_2] = 'NES-1up.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'NES-Flagpole.ogg',
    [CHAR_SOUND_HOOHOO] = 'NES-Jump.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'NES-Warp.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'NES-1up.ogg',
    [CHAR_SOUND_ON_FIRE] = 'NES-Enemy_Fire.ogg',
    [CHAR_SOUND_OOOF] = 'NES-Hit.ogg',
    [CHAR_SOUND_OOOF2] = 'NES-Hit.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'NES-Kick.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'NES-Thwomp.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'NES-Thwomp.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'NES-Bowser_Die.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'NES-Item.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'NES-Vine.ogg',
    [CHAR_SOUND_WAH2] = 'NES-Kick.ogg',
    [CHAR_SOUND_WHOA] = 'NES-Item.ogg',
    [CHAR_SOUND_YAHOO] = 'NES-Jump.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'NES-Jump.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = 'NES-Big_Jump.ogg',
    [CHAR_SOUND_YAWNING] = 'NES-Pause.ogg',
}

local VOICETABLE_NINTEN = {
    [CHAR_SOUND_ATTACKED] = 'NES-Hit.ogg',
    [CHAR_SOUND_DOH] = 'NES-Bump.ogg',
    [CHAR_SOUND_DROWNING] = 'NES-Die.ogg',
    [CHAR_SOUND_DYING] = 'NES-Die.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'NES-Squish.ogg',
    [CHAR_SOUND_HAHA] = 'NES-1up.ogg',
    [CHAR_SOUND_HAHA_2] = 'NES-1up.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'NES-Flagpole.ogg',
    [CHAR_SOUND_HOOHOO] = 'NES-Jump.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'NES-Warp.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'NES-1up.ogg',
    [CHAR_SOUND_ON_FIRE] = 'NES-Enemy_Fire.ogg',
    [CHAR_SOUND_OOOF] = 'NES-Hit.ogg',
    [CHAR_SOUND_OOOF2] = 'NES-Hit.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'NES-Kick.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'NES-Thwomp.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'NES-Thwomp.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'NES-Bowser_Die.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'NES-Item.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'NES-Vine.ogg',
    [CHAR_SOUND_WAH2] = 'NES-Kick.ogg',
    [CHAR_SOUND_WHOA] = 'NES-Item.ogg',
    [CHAR_SOUND_YAHOO] = 'NES-Jump.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'NES-Jump.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = 'NES-Big_Jump.ogg',
    [CHAR_SOUND_YAWNING] = 'NES-Pause.ogg',
}

local VOICETABLE_LUCAS = {
    [CHAR_SOUND_ATTACKED] = 'NES-Hit.ogg',
    [CHAR_SOUND_DOH] = 'NES-Bump.ogg',
    [CHAR_SOUND_DROWNING] = 'NES-Die.ogg',
    [CHAR_SOUND_DYING] = 'NES-Die.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'NES-Squish.ogg',
    [CHAR_SOUND_HAHA] = 'NES-1up.ogg',
    [CHAR_SOUND_HAHA_2] = 'NES-1up.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'NES-Flagpole.ogg',
    [CHAR_SOUND_HOOHOO] = 'NES-Jump.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'NES-Warp.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'NES-1up.ogg',
    [CHAR_SOUND_ON_FIRE] = 'NES-Enemy_Fire.ogg',
    [CHAR_SOUND_OOOF] = 'NES-Hit.ogg',
    [CHAR_SOUND_OOOF2] = 'NES-Hit.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'NES-Kick.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'NES-Thwomp.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'NES-Thwomp.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'NES-Bowser_Die.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'NES-Item.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'NES-Vine.ogg',
    [CHAR_SOUND_WAH2] = 'NES-Kick.ogg',
    [CHAR_SOUND_WHOA] = 'NES-Item.ogg',
    [CHAR_SOUND_YAHOO] = 'NES-Jump.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'NES-Jump.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = 'NES-Big_Jump.ogg',
    [CHAR_SOUND_YAWNING] = 'NES-Pause.ogg',
}
]]

local VOICETABLE_PLACEHOLDER = { nil }

-- All Located in "actors"
local CAPTABLE_NESS = {
    normal = smlua_model_util_get_id("ness_cap_geo"),
    wing = smlua_model_util_get_id("ness_wing_cap_geo"),
    metal = smlua_model_util_get_id("ness_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("ness_winged_metal_cap_geo"),
}

local CAPTABLE_LUCAS = {
    normal = smlua_model_util_get_id("lucas_cap_geo"),
    wing = smlua_model_util_get_id("lucas_wing_cap_geo"),
    metal = smlua_model_util_get_id("lucas_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("lucas_winged_metal_cap_geo"),
}

local PALETTE_NESS = {
    [PANTS]  = "6800F8",
    [SHIRT]  = "F8F000",
    [GLOVES] = "8840F8",
    [SHOES]  = "F80000",
    [HAIR]   = "000000",
    [SKIN]   = "F8D0A0",
    [CAP]    = "F80000",
    [EMBLEM] = "6800F8",
}

local PALETTE_NINTEN = {
    [PANTS]  = "5A698D",
    [SHIRT]  = "F9F800",
    [GLOVES] = "8888F8",
    [SHOES]  = "8888F8",
    [HAIR]   = "1F1F1F",
    [SKIN]   = "FFD6BF",
    [CAP]    = "F81071",
    [EMBLEM] = "8888F8",
}

local PALETTE_KEN = {
    [PANTS]  = "5A698D",
    [SHIRT]  = "A25044",
    [GLOVES] = "FFFFFF",
    [SHOES]  = "8888F8",
    [HAIR]   = "F8F800",
    [SKIN]   = "FFD6BF",
    [CAP]    = "F81071",
    [EMBLEM] = "8888F8",
}

local PALETTE_LUCAS = {
    [PANTS]  = "8888F8",
    [SHIRT]  = "F8F000",
    [GLOVES] = "F81070",
    [SHOES]  = "F80000",
    [HAIR]   = "F8F8A0",
    [SKIN]   = "F8D0A0",
    [CAP]    = "FFFF00",
    [EMBLEM] = "FFFFFF",
}

local PALETTE_EB64LUCAS = {
    [PANTS]  = "888C62",
    [SHIRT]  = "FFFFFF",
    [GLOVES] = "F81070",
    [SHOES]  = "FFFFFF",
    [HAIR]   = "E2AB2E",
    [SKIN]   = "F8D0A0",
    [CAP]    = "FFFF00",
    [EMBLEM] = "1274B7",
}

local PALETTE_DOUG = {
    [PANTS]  = "0655A0",
    [SHIRT]  = "FFFFFF",
    [GLOVES] = "3FABD1",
    [SHOES]  = "CB313B",
    [HAIR]   = "71352B",
    [SKIN]   = "E6B89E",
    [CAP]    = "CB313B",
    [EMBLEM] = "CB313B",
}

local CSloaded = false
local function on_character_select_load()
    _G.CT_NINTEN = _G.charSelect.character_add("Ninten", "This Psychic 12 year old is the grandson of the allusive George and Maria. He begins his adventure in Podunk, when a poltergeist happens at his house. the protagonist of the original Mother", "Mlops, design from Mother Encore", {r = 248, g = 16, b = 113}, E_MODEL_NINTEN, CT_MARIO, TEX_NINTEN_LIFE_ICON)
    _G.CT_NESS = _G.charSelect.character_add("Ness", "An average 12 year-old with psychic powers, who left his hometown, Onett, after meeting a hero from a ruined future. the first out of the chosen four from Mother 2", "Mlops", {r = 248, g = 0, b = 0}, E_MODEL_NESS, CT_MARIO, TEX_NESS_LIFE_ICON)
    _G.CT_LUCAS = _G.charSelect.character_add("Lucas", "A timid and nervous teen, who lost his mother and brother, Claus, at a young age. Protagonist of Mother 3.", "Mlops", {r = 255, g = 255, b = 0}, E_MODEL_LUCAS, CT_MARIO, TEX_LUCAS_LIFE_ICON)

    _G.charSelect.character_add_caps(E_MODEL_NESS, CAPTABLE_NESS)
    _G.charSelect.character_add_caps(E_MODEL_NINTEN, CAPTABLE_NESS)
    _G.charSelect.character_add_caps(E_MODEL_KEN, CAPTABLE_NESS)
    _G.charSelect.character_add_caps(E_MODEL_LUCAS, CAPTABLE_LUCAS)
    _G.charSelect.character_add_caps(E_MODEL_DOUG, CAPTABLE_NESS)
    _G.charSelect.character_add_caps(E_MODEL_EB64LUCAS, CAPTABLE_LUCAS)
    _G.charSelect.character_add_voice(E_MODEL_NESS, VOICETABLE_PLACEHOLDER)
    _G.charSelect.character_add_voice(E_MODEL_NINTEN, VOICETABLE_PLACEHOLDER)
    _G.charSelect.character_add_voice(E_MODEL_KEN, VOICETABLE_PLACEHOLDER)
    _G.charSelect.character_add_voice(E_MODEL_LUCAS, VOICETABLE_PLACEHOLDER)
    _G.charSelect.character_add_voice(E_MODEL_DOUG, VOICETABLE_PLACEHOLDER)
    _G.charSelect.character_add_voice(E_MODEL_EB64LUCAS, VOICETABLE_PLACEHOLDER)
    _G.charSelect.character_add_palette_preset(E_MODEL_NESS, PALETTE_NESS)
    _G.charSelect.character_add_palette_preset(E_MODEL_NINTEN, PALETTE_NINTEN)
    _G.charSelect.character_add_palette_preset(E_MODEL_KEN, PALETTE_KEN)
    _G.charSelect.character_add_palette_preset(E_MODEL_LUCAS, PALETTE_LUCAS)
    _G.charSelect.character_add_palette_preset(E_MODEL_DOUG, PALETTE_DOUG)
    _G.charSelect.character_add_palette_preset(E_MODEL_EB64LUCAS, PALETTE_EB64LUCAS)

    CSloaded = true
end

local function on_character_sound(m, sound)
    if not CSloaded then return end
    --if _G.charSelect.character_get_voice(m) == VOICETABLE_NESS then return _G.charSelect.voice.sound(m, sound) end
    --if _G.charSelect.character_get_voice(m) == VOICETABLE_NINTEN then return _G.charSelect.voice.sound(m, sound) end
    --if _G.charSelect.character_get_voice(m) == VOICETABLE_LUCAS then return _G.charSelect.voice.sound(m, sound) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_PLACEHOLDER then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    --if _G.charSelect.character_get_voice(m) == VOICETABLE_NESS then return _G.charSelect.voice.snore(m) end
    --if _G.charSelect.character_get_voice(m) == VOICETABLE_NINTEN then return _G.charSelect.voice.snore(m) end
    --if _G.charSelect.character_get_voice(m) == VOICETABLE_LUCAS then return _G.charSelect.voice.snore(m) end
   if _G.charSelect.character_get_voice(m) == VOICETABLE_PLACEHOLDER then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)

--------------------------------------------
--- Alt Costume code from Paper Partners ---
------------ Thanks, Melzinoff!! -----------
--------- Original code by Wibblus!! -------
--------------------------------------------

local CUR_SKIN_NINTEN = 1
-- table of skins
local SKINTABLE_NINTEN = {
    { model = E_MODEL_NINTEN,  name = "Ninten", "This Psychic 12 year old is the grandson of the allusive George and Maria. He begins his adventure in Podunk, when a poltergeist happens at his house. the protagonist of the original Mother", "Mlops, design from Mother Encore", {r = 248, g = 16, b = 113}, E_MODEL_NINTEN, CT_MARIO, TEX_NINTEN_LIFE_ICON },
    { model = E_MODEL_KEN,  name = "Ken", "This Psychic 12 year old is the grandson of the allusive George and Maria. He begins his adventure in Podunk, when a poltergeist happens at his house. the protagonist of the Mother Novelization", "Mlops", {r = 248, g = 16, b = 113}, E_MODEL_KEN, CT_MARIO, TEX_KEN_LIFE_ICON },
    { model = E_MODEL_DOUG,  name = "Douglas Halloway", "This Psychic 12 year old is the grandson of the allusive George and Maria. He begins his adventure in Podunk, when a poltergeist happens at his house. the protagonist of the Mother: Invasion From the Unknown Book.", "Mlops", {r = 248, g = 16, b = 113}, E_MODEL_DOUG, CT_MARIO, TEX_DOUG_LIFE_ICON },
}

local CUR_SKIN_LUCAS = 1
-- table of skins
local SKINTABLE_LUCAS = {
    { model = E_MODEL_LUCAS,  name = "Lucas", "A timid and nervous teen, who lost his mother and brother, Claus, at a young age. Protagonist of Mother 3.", "Mlops", {r = 255, g = 255, b = 0}, E_MODEL_LUCAS, CT_MARIO, TEX_LUCAS_LIFE_ICON },
    { model = E_MODEL_EB64LUCAS,  name = "Lucas", "A timid and nervous teen, who lost his mother and brother, Claus, at a young age. Protagonist of Mother 3. This variation is based off his design in EarthBound 64!", "Mlops", {r = 255, g = 255, b = 0}, E_MODEL_EB64LUCAS, CT_MARIO, TEX_EB64LUCAS_LIFE_ICON },
}

local function update_character_skin()
    local curNintenSkin = SKINTABLE_NINTEN[CUR_SKIN_NINTEN]
    _G.charSelect.character_edit(CT_NINTEN, curNintenSkin.name, curNintenSkin[1], curNintenSkin[2], curNintenSkin.color, curNintenSkin.model, nil, curNintenSkin[6])
end
local inputLockTimer = 0
_G.charSelect.hook_render_in_menu(function()
    if _G.charSelect.character_get_current_number() == CT_NINTEN then
        ---@type Controller
        local c = _G.charSelect.controller

        djui_hud_set_font(FONT_NORMAL)
        djui_hud_set_resolution(RESOLUTION_N64)
        local scale = 0.5
        local x1 = djui_hud_get_screen_width() * .048
        local x2 = x1 + math.max(85, djui_hud_get_screen_width() * .196)

        -- >
        if CUR_SKIN_NINTEN < #SKINTABLE_NINTEN then
            -- the < > icons move with inputLockTimer for very cool reactive ui
            djui_hud_print_text(">", x2 + inputLockTimer, 90, scale)

            if inputLockTimer == 0 and (c.buttonDown & R_JPAD ~= 0 or c.stickX > 0.5) then
                CUR_SKIN_NINTEN = CUR_SKIN_NINTEN + 1
                update_character_skin()
                inputLockTimer = 5
            end
        end
        -- <
        if CUR_SKIN_NINTEN > 1 then
            djui_hud_print_text("<", x1 - inputLockTimer, 90, scale)

            if inputLockTimer == 0 and (c.buttonDown & L_JPAD ~= 0 or c.stickX < -0.5) then
                CUR_SKIN_NINTEN = math.max(CUR_SKIN_NINTEN - 1, 1)
                update_character_skin()
                inputLockTimer = 5
            end
        end
        -- use an input lock to prevent cycling too fast
        inputLockTimer = math.max(0, inputLockTimer - 1)
    end
end)

local function update_character_skin()
    local curLucasSkin = SKINTABLE_LUCAS[CUR_SKIN_LUCAS]
    _G.charSelect.character_edit(CT_LUCAS, curLucasSkin.name, curLucasSkin[1], curLucasSkin[2], curLucasSkin.color, curLucasSkin.model, nil, curLucasSkin[6])
end
local inputLockTimer = 0
_G.charSelect.hook_render_in_menu(function()
    if _G.charSelect.character_get_current_number() == CT_LUCAS then
        ---@type Controller
        local c = _G.charSelect.controller

        djui_hud_set_font(FONT_NORMAL)
        djui_hud_set_resolution(RESOLUTION_N64)
        local scale = 0.5
        local x1 = djui_hud_get_screen_width() * .048
        local x2 = x1 + math.max(85, djui_hud_get_screen_width() * .196)

        -- >
        if CUR_SKIN_LUCAS < #SKINTABLE_LUCAS then
            -- the < > icons move with inputLockTimer for very cool reactive ui
            djui_hud_print_text(">", x2 + inputLockTimer, 90, scale)

            if inputLockTimer == 0 and (c.buttonDown & R_JPAD ~= 0 or c.stickX > 0.5) then
                CUR_SKIN_LUCAS = CUR_SKIN_LUCAS + 1
                update_character_skin()
                inputLockTimer = 5
            end
        end
        -- <
        if CUR_SKIN_LUCAS > 1 then
            djui_hud_print_text("<", x1 - inputLockTimer, 90, scale)

            if inputLockTimer == 0 and (c.buttonDown & L_JPAD ~= 0 or c.stickX < -0.5) then
                CUR_SKIN_LUCAS = math.max(CUR_SKIN_LUCAS - 1, 1)
                update_character_skin()
                inputLockTimer = 5
            end
        end
        -- use an input lock to prevent cycling too fast
        inputLockTimer = math.max(0, inputLockTimer - 1)
    end
end)